VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "CFile Class Testing App"
   ClientHeight    =   5730
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8760
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5730
   ScaleWidth      =   8760
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin RichTextLib.RichTextBox rtfTx 
      Height          =   5475
      Left            =   105
      TabIndex        =   0
      Top             =   120
      Width           =   8550
      _ExtentX        =   15081
      _ExtentY        =   9657
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      Appearance      =   0
      TextRTF         =   $"frmMain.frx":058A
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type FUNNYSTRUCT
    Chars(4) As Byte
    Chars2(0) As Byte
    Int As Integer
    Lng As Long
End Type

Dim WithEvents at As EErrStd
Attribute at.VB_VarHelpID = -1
Dim nf As EDErrStd
Attribute nf.VB_VarHelpID = -1

Private Sub at_Exception(Info As IErrorData)
    DebugPrint "Error #" & Info.Number & ", source: " & IIf(Info.Kind = kdApi, "Win32 API", "VB6 Runtime") & IIf(Len(Info.Description) <> 0, ", description: '" & Info.Description & "'", vbNullString)
End Sub

Private Sub Form_Load()
On Error Resume Next
    Dim a As CFile
    Set a = New CFile
    a.P_FileName = "C:\AUTOEXEC.BAT"
    
    DebugPrint "INPUT PROCEDURES TESTING"
    DebugPrint
    DebugPrint
    DebugPrint "Length of File:"
    DebugPrint Trim$(Str$(a.I_Length)) & " bytes"
    DebugPrint
    DebugPrint
    DebugPrint "All Contents Of File:"
    DebugPrint a.I_All
    DebugPrint
    DebugPrint "All Lines, beginning with #3:"
    DebugPrint a.I_Lines(3)
    DebugPrint
    DebugPrint "2 Lines, beginning with #3:"
    DebugPrint a.I_Lines(3, 2)
    DebugPrint
    DebugPrint "1 Line, beginning with #3:"
    DebugPrint a.I_Lines(3, 1)
    DebugPrint
    DebugPrint "2 Lines, beginning with #2:"
    DebugPrint a.I_Lines(2, 2)
    DebugPrint
    DebugPrint "Byte at Pos #400:"
    DebugPrint Chr(a.I_Byte(400)) & " (" & Trim$(Str$(a.I_Byte(400))) & ")"
    DebugPrint
    DebugPrint "10 Next Bytes from Pos #400 (As String):"
    DebugPrint a.I_BytesAsStr(400, 10)
    DebugPrint
    
    Dim fp As FUNNYSTRUCT
    fp.Chars(0) = 87
    fp.Chars(1) = 88
    fp.Chars(2) = 89
    fp.Chars(3) = 90
    fp.Chars(4) = 91
    fp.Chars2(0) = 92
    fp.Int = 100
    fp.Lng = 2005
    
    Close
    Open "C:\NEWFILE.TXT" For Binary As #1
    Put #1, , fp
    Close
    
    a.P_FileName = "C:\NEWFILE.TXT"
    Dim fs As FUNNYSTRUCT
    a.I_BytesAsStruct 0, VarPtr(fs), Len(fs)
    DebugPrint "Structure Reading:"
    DebugPrint fs.Chars(0) & " " & fs.Chars(1) & _
    " " & fs.Chars(2) & " " & fs.Chars(3) & " " & fs.Chars(4)
    DebugPrint fs.Chars2(0)
    DebugPrint fs.Int
    DebugPrint fs.Lng
    
    a.P_FileName = "C:\AUTOEXEC.BAT"
    DebugPrint ""
    DebugPrint "Position in File:"
    DebugPrint a.I_Pos(0, "SET winbootDir=", vbTextCompare)
    DebugPrint a.I_Pos(0, "SET winbootDir=", vbBinaryCompare)
    DebugPrint ""
    DebugPrint "All Data From Specific Position:"
    DebugPrint a.I_BytesAsStr(a.I_Pos(0, "SET winbootDir=", vbTextCompare) - 1, 0)
    
    Dim r(99) As Byte
    a.I_BytesAsArr 0, r, 100
    DebugPrint ""
    DebugPrint "Bytes As Array -> String:"
    DebugPrint StrConv(r, vbUnicode)
    
    a.P_FileName = "C:\NTDETECT.COM"
    DebugPrint ""
    DebugPrint "Attribute Output:"
    DebugPrint ""
    DebugPrint Trim$(Str$(a.P_Attributes))
    DebugPrint a.G_AttrAsStr("-")
    a.P_FileName = "C:\AUTOEXEC.BAT"
    
    DebugPrint ""
    DebugPrint "File Extention:"
    DebugPrint a.G_FileExt
    DebugPrint ""
    
    DebugPrint
    DebugPrint "Full File Path:"
    a.P_FileName = "WIZARDS\OUT.TXT"
    DebugPrint a.G_FullPath
    DebugPrint
    
    a.P_FileName = "\\server\dev\null"
    DebugPrint "File Root:"
    DebugPrint a.G_FilePathRoot
    DebugPrint
    DebugPrint "File Paths"
    DebugPrint a.G_FilePath(0)
    DebugPrint a.G_FilePath(1)
    DebugPrint a.G_FilePath(2)
    DebugPrint
    
    DebugPrint "Format File Renaming:"
    a.P_FileName = "C:\FORMAT.TXT"
    a.G_Rename "C:\FORMAT2.TXT"
    a.P_FileName = "C:\FORMAT2.TXT"
    DebugPrint a.I_Length
    DebugPrint
    a.G_Rename "C:\FORMAT.TXT"
    a.P_FileName = "C:\FORMAT.TXT"
    DebugPrint a.I_Length
    DebugPrint
    
    a.G_Copy "C:\AAA.TXT"
    a.P_FileName = "C:\AAA.TXT"
    a.G_Move "D:"
    a.P_FileName = "D:\AAA.TXT"
    a.G_Remove True
    a.P_FileName = "C:\AAA.TXT"
    a.G_Remove True
    
    DebugPrint "OUTPUT PROCEDURES TESTING"
    DebugPrint
       
    DebugPrint "String Output:"
    a.P_FileName = "C:\AUTOEXEC.RATS"
    
    '    "" 
    ' .  ? ,
    '   .
    'a.P_Overwrite = False
    a.O_All " !!!"
    DebugPrint a.I_All
    
    DebugPrint
    DebugPrint "Byte Array Output:"
    Dim od() As Byte
    od = StrConv(" !!!", vbFromUnicode)
    a.O_Bytes od
    DebugPrint a.I_All
    
    '     !
    a.P_Overwrite = False
    
    DebugPrint
    DebugPrint "Structure Output:"
    
    Dim fp2 As FUNNYSTRUCT, fp3 As FUNNYSTRUCT
    fp2.Chars(0) = 1
    fp2.Chars(1) = 2
    fp2.Chars(2) = 3
    fp2.Chars(3) = 4
    fp2.Chars(4) = 5
    fp2.Chars2(0) = 6
    fp2.Int = 7
    fp2.Lng = 8
    
    a.P_FileName = "C:\AUTOEXEC.GOOD"
    a.O_Struct VarPtr(fp2), Len(fp2)
    a.I_BytesAsStruct 0, VarPtr(fp3), Len(fp3)
    
    DebugPrint fp3.Chars(0) & " " & fp3.Chars(1) & " " & _
    fp3.Chars(2) & " " & fp3.Chars(3) & " " & fp3.Chars(4)
    DebugPrint fp3.Chars2(0)
    DebugPrint fp3.Int
    DebugPrint fp3.Lng
    
    DebugPrint
    DebugPrint "FILE DATES (Before):"
    DebugPrint
    DebugPrint "File Creation Date:"
    DebugPrint a.P_CreationDate
    DebugPrint "File Last Access Date:"
    DebugPrint a.P_LastAccessDate
    DebugPrint "File Last Write Date:"
    DebugPrint a.P_LastWriteDate
    
    ' 
    a.P_CreationDate = CDate(Now) - 1
    a.P_LastAccessDate = CDate(Now)
    a.P_LastWriteDate = CDate(Now) + 1
    
    DebugPrint
    DebugPrint "FILE DATES (After):"
    DebugPrint
    DebugPrint "File Creation Date:"
    DebugPrint a.P_CreationDate
    DebugPrint "File Last Access Date:"
    DebugPrint a.P_LastAccessDate
    DebugPrint "File Last Write Date:"
    DebugPrint a.P_LastWriteDate
    
    DebugPrint
    DebugPrint "EXCEPTION NOTIFICATION"
    DebugPrint
    Set at = New EErrStd
    Set nf = New EDErrStd
    Dim sTmp As Variant
    a.E_Attach at, nf
    a.P_FileName = "C:\alr.dat"
    a.G_Copy "C:\aaa"
    DebugPrint String(20, "-")
    a.P_FileName = "*"
    sTmp = a.G_FilePath(404)
    DebugPrint String(20, "-")
    sTmp = a.P_CreationDate
    DebugPrint String(20, "-")
    sTmp = a.P_LastAccessDate
    DebugPrint String(20, "-")
    sTmp = a.P_LastWriteDate
    DebugPrint String(20, "-")
    sTmp = a.I_All
    DebugPrint String(20, "-")
    a.P_FileName = "Z:\rrr"
    sTmp = a.P_Attributes
    DebugPrint String(20, "-")
    a.E_Detach
        
    Set a = Nothing
    
    DebugPrint
    DebugPrint "Yeah, that's all for now!"
    DebugPrint "Enjoy!.."
End Sub

Private Sub DebugPrint(Optional Str As Variant = Null)
On Error Resume Next
    Dim st As String
    If IsNull(Str) Then st = ""
    st = CStr(Str)
    rtfTx.Text = rtfTx.Text & st & vbCrLf
End Sub

Private Sub DebugClear()
On Error Resume Next
    rtfTx.Text = vbNullString
End Sub

